import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;

public class DoubleClickList extends JList implements MouseListener
{

	public DoubleClickList()
	{
		super();
		init();
	}
	
	public DoubleClickList(ListModel dataModel)
	{
		super(dataModel);
		init();
	}
	
	public DoubleClickList(Object[] listData)
	{
		super(listData);
		init();
	}
	
	public DoubleClickList(Vector listData)
	{
		super(listData);
		init();
	}
	
	protected void init()
	{
		addMouseListener(this);
	}
	
	public void mousePressed(MouseEvent me) { }
	public void mouseReleased(MouseEvent me) { }
	public void mouseEntered(MouseEvent me) { }
	public void mouseExited(MouseEvent me) { }
	
	public void mouseClicked(MouseEvent me)
	{
		if (me.getClickCount() == 2)
		{
			fireActionPerformed(new ActionEvent(
				this, ActionEvent.ACTION_PERFORMED,
				"[" + this.getSelectedIndex() + "]" ) );
			me.consume();
		}
		
	}
	
	public void addActionListener(ActionListener l)
	{
		listenerList.add(ActionListener.class, l);
	}

	public void removeActionListener(ActionListener l)
	{
		listenerList.remove(ActionListener.class, l);
	}

	protected void fireActionPerformed(ActionEvent ae)
	{
		Object[] listeners = listenerList.getListenerList();
		for (int i = listeners.length - 2; i >= 0; i -= 2)
		{
			if (listeners[i] == ActionListener.class)
			{
				((ActionListener) listeners[i+1]).actionPerformed(ae);
			}
		}
	}
}

