Double click on a JList

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class DClickJList extends JPanel {
 public DClickJList() {
  JList list = new JList();;
  Vector data = new Vector();;
  data.addElement("line 1");
  data.addElement("line 2");
  data.addElement("line 3");
  list.setListData(data);
  list.setSelectedIndex(0);
  list.addMouseListener(new ActionJList(list));
  add(new JScrollPane(list));
  }

 public Dimension getPreferredSize() {
  return new Dimension(100, 100);
  }
    
 public static void main(String s[]){
  JFrame frame = new JFrame("DClickJList");
  DClickJList panel = new DClickJList();
        
  frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
  frame.getContentPane().add(panel,"Center");
  frame.setSize(panel.getPreferredSize());
  frame.setVisible(true);
  }
}

class ActionJList extends MouseAdapter{
  protected JList list;
    
  public ActionJList(JList l){
   list = l;
   }
    
  public void mouseClicked(MouseEvent e){
   if(e.getClickCount() == 2){
     int index = list.locationToIndex(e.getPoint());
     ListModel dlm = list.getModel();
     Object item = dlm.getElementAt(index);;
     list.ensureIndexIsVisible(index);
     System.out.println("Double clicked on " + item);
     }
   }
}

============================
[Jump to Real's How-to Main page]
Make a JList select an item on doubleclick or the ENTER key

import com.sun.java.swing.*;
//import javax.swing.*;
import java.awt.event.*;

public class ActionJList extends JList {
 /*
 ** sends ACTION_PERFORMED event for double-click
 ** and ENTER key
 */
 ActionListener al;

 public ActionJList(String[] it){
  super(it);

 addMouseListener(new MouseAdapter() {
  public void mouseClicked(MouseEvent me) {
   if (al == null) return;
   Object ob[] = getSelectedValues();
   if (ob.length > 1) return;
   if (me.getClickCount() == 2) {
     System.out.println("Sending ACTION_PERFORMED to ActionListener");
     al.actionPerformed(new ActionEvent(this,
        ActionEvent.ACTION_PERFORMED,
        ob[0].toString()));
     me.consume();
     }
   }
  });

  addKeyListener(new KeyAdapter() {
   public void keyReleased(KeyEvent ke) {
    if (al == null) return;
    Object ob[] = getSelectedValues();
    if (ob.length > 1) return;
      if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
        System.out.println("Sending ACTION_PERFORMED to ActionListener");
        al.actionPerformed(new ActionEvent(this,
        ActionEvent.ACTION_PERFORMED,
        ob[0].toString()));
        ke.consume();
        } 
    }
   });
   this.setSelectedIndex(0); 
  }

  public void addActionListener(ActionListener al){
   this.al = al;
   }
}

To try it:

import com.sun.java.swing.*;
//import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class TestActionJList {
 public static void main(String args[]) {
  JFrame jf = new JFrame();
  jf.getContentPane().add(new PanelWithActionJList());
  jf.pack();
  jf.setVisible(true);
  }

}

class PanelWithActionJList extends JPanel {
 public PanelWithActionJList() {
  setLayout(new GridLayout(1,1));

  String[] items = 
    { "item 0", "item 1", "item 2", "item 3" , "item 4",
      "item 5", "item 6", "item 7", "item 8" , "item 9" };
  
  final ActionJList ajl = new ActionJList(items);

  ajl.setVisibleRowCount(5);
  ajl.addActionListener(
    new ActionListener() {
       public void actionPerformed(ActionEvent ae) {
        System.out.println("action in Panel " + ajl.getSelectedValue()); 
        }
    });

  JScrollPane jsp = new JScrollPane();
  jsp.getViewport().add(ajl);
  add(jsp);
  }
}

Written and compiled by Ral Gagnon 1998-2000 mailto:real@rgagnon.com

=====================
final JList list = new JList(dataModel);
MouseListener mouseListener = new MouseAdapter() {
    public void mouseClicked(MouseEvent e) {
        if (e.getClickCount() == 2) {
            int index = list.locationToIndex(e.getPoint());
            System.out.println("Double clicked on Item " + index);
         }
    }
};
list.addMouseListener(mouseListener);
    

